<!--********************************************************************************
 * Copyright (c) 2015, 2023 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ********************************************************************************-->

<p-panel toggler="header" [toggleable]="true" [collapsed]="!basketOpen" [style.line-height]="1">
  <ng-template pTemplate="header">
    <span class="font-bold">{{ "basket.mdm-basket.shopping-basket" | translate }}</span> &nbsp;&nbsp;
    <mdm-view #mdmview stateKey="basket-view" (click)="onViewClick($event)" (view)="onViewChanged($event)"></mdm-view>
  </ng-template>
  <ng-template pTemplate="icons">
    <p-button
      icon="fa fa-line-chart"
      (onClick)="quickPlotMetadataTrends($event)"
      [title]="'basket.mdm-basket.quick-plot' | translate"
    ></p-button>
    <p-button
      styleClass="ml-1 mr-1"
      icon="fa fa-area-chart"
      (onClick)="addToChartViewer($event, false)"
      [title]="'basket.mdm-basket.add-to-chart' | translate"
    ></p-button>
    <mdm-sharelink
      componentFilter="basket"
      (click)="$event.stopPropagation()"
      title="{{ 'tableview.view.tooltip-share-basket' | translate }}"
    ></mdm-sharelink>

    <p-splitButton
      icon="fa fa-arrow-circle-o-down"
      styleClass="ml-3"
      class="dropdown"
      (onClick)="saveBasketWithExtension($event, 'mdm')"
      (onDropdownClick)="stopEvent($event)"
      [title]="'basket.mdm-basket.tooltip-download-shopping-basket' | translate"
      [model]="launchers"
      [disabled]="isDownloadDisabled()"
    ></p-splitButton>
    <p-fileUpload
      chooseIcon="fa fa-arrow-circle-o-up"
      mode="basic"
      [customUpload]="true"
      [auto]="true"
      (uploadHandler)="onUploadEvent($event)"
      (click)="$event.stopPropagation()"
      [title]="'basket.mdm-basket.tooltip-upload-shopping-basket' | translate"
    ></p-fileUpload>
    <p-button
      icon="pi pi-file-import"
      styleClass="ml-1"
      (onClick)="showFileImportDialog($event)"
      [title]="'basket.mdm-basket.tooltip-file-import' | translate"
    ></p-button>

    <p-button
      icon="fa fa-eraser"
      styleClass="ml-3"
      (onClick)="clearBasket($event)"
      [title]="'basket.mdm-basket.tooltip-clear-shopping-basket' | translate"
    ></p-button>
    <p-button
      icon="fa fa-folder-open"
      styleClass="ml-1"
      (onClick)="showLoadModal($event)"
      [title]="'basket.mdm-basket.tooltip-open-shopping-basket' | translate"
    ></p-button>
    <p-button
      icon="pi pi-save"
      styleClass="ml-1"
      (onClick)="showSaveModal($event)"
      [title]="'basket.mdm-basket.tooltip-save-shopping-basket' | translate"
    ></p-button>
  </ng-template>
  <ng-template pTemplate="content">
    <div class="container-fluid">
      <div class="row">
        <mdm-tableview
          #mdmtableview
          [results]="basketContent"
          [view]="selectedView"
          isRemovable="true"
          [menuItems]="contextMenuItems"
          [selectedEnvs]="environments"
          [environments]="environments"
          [idField]="'virtualId'"
          (selectedRow)="onSelectedRowChanged($event)"
          (selectedRows)="onSelectedRowsChanged($event)"
        >
        </mdm-tableview>
      </div>
    </div>
  </ng-template>
</p-panel>

<p-confirmDialog header="Information" icon="pi pi-exclamation-triangle"></p-confirmDialog>

<p-dialog
  header="{{ 'basket.mdm-basket.quick-plot' | translate }}"
  [(visible)]="lgQuickPlotModal"
  [modal]="true"
  [style]="{ width: '75vw' }"
>
  <mdm-quick-plot [items]="this.selectedItems"></mdm-quick-plot>
</p-dialog>

<p-dialog header="{{ 'basket.mdm-basket.load-shopping-basket' | translate }}" [(visible)]="lgLoadModal">
  <div class="row" *ngIf="baskets.length > 0">
    <ul class="list-group" style="max-height: 80vh; padding: 0; list-style-type: none; overflow-y: auto">
      <div style="display: table; width: 100%; border: 1px solid #ddd">
        <li
          class="list-group-item"
          *ngFor="let basket of baskets"
          [ngClass]="{ active: selectedBasket === basket }"
          (click)="toggleSelect(basket)"
          (dblclick)="loadBasket(basket)"
          style="cursor: pointer"
        >
          {{ basket.name }}<span class="badge">{{ basket.items.length }}</span>
        </li>
      </div>
    </ul>
  </div>
  <div class="row" *ngIf="baskets.length === 0">
    {{ "basket.mdm-basket.no-saved-shopping-baskets-available" | translate }}
  </div>
  <button
    type="button"
    class="btn btn-outline-secondary pull-right"
    (click)="loadBasket()"
    [disabled]="baskets.length <= 0 || selectedBasket === undefined"
  >
    <span class="fa fa-upload"></span> {{ "basket.mdm-basket.btn-load" | translate }}
  </button>
</p-dialog>

<mdm-file-import-dialog [(showDialog)]="displayImportDialog"></mdm-file-import-dialog>

<p-dialog header="{{ 'basket.mdm-basket.save-basket-as' | translate }}" [(visible)]="lgSaveModal">
  <p-table
    *ngIf="baskets.length > 0"
    [value]="baskets"
    resizableColumns="false"
    [reorderableColumns]="false"
    [rows]="10"
    [paginator]="true"
    [pageLinks]="3"
    [rowsPerPageOptions]="[10, 20, 50]"
    selectionMode="single"
    (onRowClick)="onBasketSelect($event)"
    (onRowSelect)="onBasketSelect($event)"
    styleClass="table-hover p-datatable-gridlines"
  >
    <ng-template pTemplate="header">
      <tr>
        <th>
          {{ "basket.mdm-basket.existing-shopping-baskets" | translate }}
        </th>
      </tr>
    </ng-template>
    <ng-template pTemplate="body" let-basket>
      <tr [pSelectableRow]="basket">
        <td>
          {{ basket.name }}
        </td>
      </tr>
    </ng-template>
  </p-table>
  <input
    type="text"
    class="form-control"
    placeholder="{{ 'basket.mdm-basket.shopping-basket-name' | translate }}"
    [value]="basketName"
    (input)="basketName = $event.target.value"
    (keyup.enter)="saveBasket($event)"
    required
  />

  <button
    type="button"
    class="btn btn-outline-secondary pull-right"
    (click)="saveBasket($event)"
    [disabled]="!basketName"
    title="{{ getSaveBtnTitle() }}"
  >
    <span class="pi pi-save"></span> {{ "basket.mdm-basket.btn-shopping-basket" | translate }}
  </button>
</p-dialog>

<mdm-overwrite-dialog></mdm-overwrite-dialog>
